# PSTUNClient Class Reference

STUN client. More...

`#include <pstun.h>`

Inheritance diagram for PSTUNClient:

List of all members.

## Public Types

| DefaultPort = 3478
| UnknownNat
| OpenNat
| ConeNat
| RestrictedNat
| PortRestrictedNat
| SymmetricNat
| SymmetricFirewall
| BlockedNat
| PartialBlockedNat
| NumNatTypes
enum | { DefaultPort = 3478 }
enum | NatTypes { UnknownNat, OpenNat, ConeNat, RestrictedNat, PortRestrictedNat, SymmetricNat, SymmetricFirewall, BlockedNat, PartialBlockedNat, NumNatTypes }

## Public Member Functions

| PSTUNClient ()
| PSTUNClient (const PString &server, WORD portBase=0, WORD portMax=0, WORD portPairBase=0, WORD portPairMax=0)
| PSTUNClient (const PIPSocket::Address &serverAddress, WORD serverPort=DefaultPort, WORD portBase=0, WORD portMax=0, WORD portPairBase=0, WORD portPairMax=0)
void | Initialise (const PString &server, WORD portBase=0, WORD portMax=0, WORD portPairBase=0, WORD portPairMax=0)
virtual PString | GetName () const
| Get the NAT traversal method name.
virtual bool | GetServerAddress (PIPSocket::Address &address, WORD &port) const
| Get the current server address and port being used.
PBoolean | SetServer (const PString &server)
| Set the STUN server to use.
PBoolean | SetServer (const PIPSocket::Address &serverAddress, WORD serverPort=0)
| Set the STUN server to use by IP address and port.
NatTypes | GetNatType (PBoolean force=false)
| Determine via the STUN protocol the NAT type for the router.
PString | GetNatTypeName (PBoolean force=false)
| Determine via the STUN protocol the NAT type for the router.
RTPSupportTypes | GetRTPSupport (PBoolean force=false)
| Return an indication if the current STUN type supports RTP Use the force variable to guarantee an up to date test.
virtual PBoolean | GetExternalAddress (PIPSocket::Address &externalAddress, const PTimeInterval &maxAge=1000)
| Determine the external router address.
virtual bool | GetInterfaceAddress (PIPSocket::Address &internalAddress) const
| Return the interface NAT router is using.
void | InvalidateCache ()
| Invalidates the cached addresses and modes.
PBoolean | CreateSocket (PUDPSocket *&socket, const PIPSocket::Address &binding=PIPSocket::GetDefaultIpAny(), WORD localPort=0)
| Create a single socket.
virtual PBoolean | CreateSocketPair (PUDPSocket *&socket1, PUDPSocket *&socket2, const PIPSocket::Address &binding=PIPSocket::GetDefaultIpAny())
| Create a socket pair.
const PTimeInterval | GetTimeout () const
| Get the timeout for responses from STUN server.
void | SetTimeout (const PTimeInterval &timeout)
| Set the timeout for responses from STUN server.
PINDEX | GetRetries () const
| Get the number of retries for responses from STUN server.
void | SetRetries (PINDEX retries)
| Set the number of retries for responses from STUN server.
PINDEX | GetSocketsForPairing () const
| Get the number of sockets to create in attempt to get a port pair.
void | SetSocketsForPairing (PINDEX numSockets)
| Set the number of sockets to create in attempt to get a port pair.
virtual bool | IsAvailable (const PIPSocket::Address &binding=PIPSocket::GetDefaultIpAny())
| Returns whether the Nat Method is ready and available in assisting in NAT Traversal.

## Static Public Member Functions

static PStringList | GetNatMethodName ()
| Get the NAT Method Name.
static PString | GetNatTypeString (NatTypes type)
| Get NatTypes enumeration as an English string for the type.

## Protected Member Functions

bool | OpenSocket (PUDPSocket &socket, PortInfo &portInfo, const PIPSocket::Address &binding)

## Protected Attributes

PString | serverHost
WORD | serverPort
PTimeInterval | replyTimeout
PINDEX | pollRetries
PINDEX | numSocketsForPairing
NatTypes | natType
PIPSocket::Address | cachedServerAddress
PIPSocket::Address | cachedExternalAddress
PIPSocket::Address | interfaceAddress
PTime | timeAddressObtained

## Detailed Description

STUN client.

## Member Enumeration Documentation

anonymous enum

Enumerator:

  DefaultPort |

enum PSTUNClient::NatTypes

Enumerator:

  UnknownNat |
  OpenNat |
  ConeNat |
  RestrictedNat |
  PortRestrictedNat |
  SymmetricNat |
  SymmetricFirewall |
  BlockedNat |
  PartialBlockedNat |
  NumNatTypes |

## Constructor & Destructor Documentation

PSTUNClient::PSTUNClient | ( |  | ) |

PSTUNClient::PSTUNClient | ( | const PString & | server,
|  | WORD | portBase = `0`,
|  | WORD | portMax = `0`,
|  | WORD | portPairBase = `0`,
|  | WORD | portPairMax = `0` |
| ) |  |  |

PSTUNClient::PSTUNClient | ( | const PIPSocket::Address & | serverAddress,
|  | WORD | serverPort = `DefaultPort`,
|  | WORD | portBase = `0`,
|  | WORD | portMax = `0`,
|  | WORD | portPairBase = `0`,
|  | WORD | portPairMax = `0` |
| ) |  |  |

## Member Function Documentation

PBoolean PSTUNClient::CreateSocket | ( | PUDPSocket *& | socket,
|  | const PIPSocket::Address & | binding = `PIPSocket::GetDefaultIpAny()`,
|  | WORD | localPort = `0` |
| ) |  |  | `[virtual]`

Create a single socket.

The STUN protocol is used to create a socket for which the external IP address and port numbers are known. A PUDPSocket descendant is returned which will, in response to GetLocalAddress() return the externally visible IP and port rather than the local machines IP and socket.

The will create a new socket pointer. It is up to the caller to make sure the socket is deleted to avoid memory leaks.

The socket pointer is set to NULL if the function fails and returns false.

Implements PNatMethod.

virtual PBoolean PSTUNClient::CreateSocketPair | ( | PUDPSocket *& | socket1,
|  | PUDPSocket *& | socket2,
|  | const PIPSocket::Address & | binding = `PIPSocket::GetDefaultIpAny()` |
| ) |  |  | `[virtual]`

Create a socket pair.

The STUN protocol is used to create a pair of sockets with adjacent port numbers for which the external IP address and port numbers are known. PUDPSocket descendants are returned which will, in response to GetLocalAddress() return the externally visible IP and port rather than the local machines IP and socket.

The will create new socket pointers. It is up to the caller to make sure the sockets are deleted to avoid memory leaks.

The socket pointers are set to NULL if the function fails and returns false.

Implements PNatMethod.

virtual PBoolean PSTUNClient::GetExternalAddress | ( | PIPSocket::Address & | externalAddress,
|  | const PTimeInterval & | maxAge = `1000` |
| ) |  |  | `[virtual]`

Determine the external router address.

This will send UDP packets out using the STUN protocol to determine the intervening routers external IP address.

A cached address is returned provided it is no older than the time specified.

Parameters:

  externalAddress | External address of router
  maxAge | Maximum age for caching

Implements PNatMethod.

virtual bool PSTUNClient::GetInterfaceAddress | ( | PIPSocket::Address & | internalAddress | ) | const`[virtual]`

Return the interface NAT router is using.

Implements PNatMethod.

virtual PString PSTUNClient::GetName | ( |  | ) | const`[inline, virtual]`

Get the NAT traversal method name.

Implements PNatMethod.

static PStringList PSTUNClient::GetNatMethodName | ( |  | ) | `[inline, static]`

Get the NAT Method Name.

NatTypes PSTUNClient::GetNatType | ( | PBoolean | force = `false` | ) |

Determine via the STUN protocol the NAT type for the router.

This will cache the last determine NAT type. Use the force variable to guarantee an up to date value.

Parameters:

  force | Force a new check

PString PSTUNClient::GetNatTypeName | ( | PBoolean | force = `false` | ) | `[inline]`

Determine via the STUN protocol the NAT type for the router.

As for GetNatType() but returns an English string for the type.

Parameters:

  force | Force a new check

static PString PSTUNClient::GetNatTypeString | ( | NatTypes | type | ) | `[static]`

Get NatTypes enumeration as an English string for the type.

Parameters:

  type | NAT Type to get name of

PINDEX PSTUNClient::GetRetries | ( |  | ) | const`[inline]`

Get the number of retries for responses from STUN server.

RTPSupportTypes PSTUNClient::GetRTPSupport | ( | PBoolean | force = `false` | ) | `[virtual]`

Return an indication if the current STUN type supports RTP Use the force variable to guarantee an up to date test.

Parameters:

  force | Force a new check

Implements PNatMethod.

virtual bool PSTUNClient::GetServerAddress | ( | PIPSocket::Address & | address,
|  | WORD & | port |
| ) |  |  | const`[virtual]`

Get the current server address and port being used.

Parameters:

  address | Address of server
  port | Port server is using.

Implements PNatMethod.

PINDEX PSTUNClient::GetSocketsForPairing | ( |  | ) | const`[inline]`

Get the number of sockets to create in attempt to get a port pair.

RTP requires a pair of consecutive ports. To get this several sockets must be opened and fired through the NAT firewall to get a pair. The busier the firewall the more sockets will be required.

const PTimeInterval PSTUNClient::GetTimeout | ( |  | ) | const`[inline]`

Get the timeout for responses from STUN server.

void PSTUNClient::Initialise | ( | const PString & | server,
|  | WORD | portBase = `0`,
|  | WORD | portMax = `0`,
|  | WORD | portPairBase = `0`,
|  | WORD | portPairMax = `0` |
| ) |  |  |

void PSTUNClient::InvalidateCache | ( |  | ) |

Invalidates the cached addresses and modes.

This allows to lazily update the external address cache at the next attempt to get the external address.

virtual bool PSTUNClient::IsAvailable | ( | const PIPSocket::Address & | binding = `PIPSocket::GetDefaultIpAny()` | ) | `[virtual]`

Returns whether the Nat Method is ready and available in assisting in NAT Traversal.

The principal is this function is to allow the EP to detect various methods and if a method is detected then this method is available for NAT traversal. The availablity of the STUN Method is dependant on the Type of NAT being used.

Parameters:

  binding | Interface to see if NAT is available on

Implements PNatMethod.

bool PSTUNClient::OpenSocket | ( | PUDPSocket & | socket,
|  | PortInfo & | portInfo,
|  | const PIPSocket::Address & | binding |
| ) |  |  | `[protected]`

void PSTUNClient::SetRetries | ( | PINDEX | retries | ) | `[inline]`

Set the number of retries for responses from STUN server.

Parameters:

  retries | Number of retries

PBoolean PSTUNClient::SetServer | ( | const PIPSocket::Address & | serverAddress,
|  | WORD | serverPort = `0` |
| ) |  |  |

Set the STUN server to use by IP address and port.

If serverPort is zero then the default port of 3478 is used.

PBoolean PSTUNClient::SetServer | ( | const PString & | server | ) |

Set the STUN server to use.

The server string may be of the form host:port. If :port is absent then the default port 3478 is used. The substring port can also be a service name as found in /etc/services. The host substring may be a DNS name or explicit IP address.

void PSTUNClient::SetSocketsForPairing | ( | PINDEX | numSockets | ) | `[inline]`

Set the number of sockets to create in attempt to get a port pair.

RTP requires a pair of consecutive ports. To get this several sockets must be opened and fired through the NAT firewall to get a pair. The busier the firewall the more sockets will be required.

Parameters:

  numSockets | Number opf sockets to create

void PSTUNClient::SetTimeout | ( | const PTimeInterval & | timeout | ) | `[inline]`

Set the timeout for responses from STUN server.

Parameters:

  timeout | New timeout in milliseconds

## Member Data Documentation

PIPSocket::Address PSTUNClient::cachedExternalAddress `[protected]`

PIPSocket::Address PSTUNClient::cachedServerAddress `[protected]`

PIPSocket::Address PSTUNClient::interfaceAddress `[protected]`

NatTypes PSTUNClient::natType `[protected]`

PINDEX PSTUNClient::numSocketsForPairing `[protected]`

PINDEX PSTUNClient::pollRetries `[protected]`

PTimeInterval PSTUNClient::replyTimeout `[protected]`

PString PSTUNClient::serverHost `[protected]`

WORD PSTUNClient::serverPort `[protected]`

PTime PSTUNClient::timeAddressObtained `[protected]`

The documentation for this class was generated from the following file:

- pstun.h